Imports System.Drawing.Drawing2D
Public Class Form1

  ' vb@rchiv - Das groe Visual Basic Archiv
  '
  ' Copyright 2000-2009 Dieter Otter
  '
  ' Der Programmcode darf fr eigene Zwecke verwendet werden.
  ' Es ist nicht erlaubt Inhalte des Projektes (Source) ohne unserer
  ' Zustimmung zum Download anzubieten.
  '
  ' Die Beispielskripte sind Computerprogramme, die gem
  ' des 2 Abs. 1 Nr. 69 aff. UrhG den urheberrechtlichen
  ' Schutz geniessen und drfen nicht fr eigene ausgegeben
  ' werden.
  '
  ' Dieter Otter
  ' Software-Entwicklung & Vertrieb
  ' info@vbarchiv.de
  ' http://www.vbarchiv.de
  '
  ' info@tools4vb.de
  ' http://www.tools4vb.de
  '======================================================

  Public Class ListItemEx
    ' Eigenschaftsvariablen
    Dim m_Text As String
    Dim m_ItemData As Integer

    ' Initialisiern: Text und ItemData werden bergeben
    Public Sub New(ByVal Text As String, ByVal ItemData As Integer)
      m_Text = Text
      m_ItemData = ItemData
    End Sub

    ' Text-Eigenschaft (Wert, der in der ComboBox-Liste angezeigt wird)
    Property Text() As String
      Get
        Return m_Text
      End Get
      Set(ByVal Value As String)
        m_Text = Value
      End Set
    End Property

    ' ItemData-Eigenschaft (Wert, der zustzlich zu jedem Eintrag gespeichert wird)
    Property ItemData() As Integer
      Get
        Return (m_ItemData)
      End Get
      Set(ByVal Value As Integer)
        m_ItemData = Value
      End Set
    End Property

    Public Overrides Function ToString() As String
      Return m_Text
    End Function
  End Class

  Private Sub imgLogo_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles imgLogo.Click
    ' URL laden
    System.Diagnostics.Process.Start("http://www.vbarchiv.net")
  End Sub

  Private Sub lnkURL_Click(ByVal sender As Object, ByVal e As System.EventArgs) Handles lnkURL.Click
    ' URL laden
    System.Diagnostics.Process.Start("http://www.vbarchiv.net")
  End Sub

  Private Sub Panel2_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Panel2.Paint
    ' Hintergrund-Farbverlauf erstellen
    ' Gre der Form
    Dim oRect As New Rectangle(0, 0, Panel2.Width, Panel2.Height)

    ' Neues Brush-Objekt mit den gewnschten Farben und
    ' Farbverlauf-Richtung erstellen
    Dim oBrush As New LinearGradientBrush(oRect, Color.FromArgb(255, 231, 247, 255), Color.FromArgb(255, 181, 214, 255), _
      LinearGradientMode.Vertical)

    ' Hintergrund-Farbverlauf anzeigen
    e.Graphics.FillRectangle(oBrush, oRect)
  End Sub

  Private Sub Panel1_Paint(ByVal sender As Object, ByVal e As System.Windows.Forms.PaintEventArgs) Handles Panel1.Paint
    ' Hintergrund-Farbverlauf erstellen
    ' Gre der Form
    Dim oRect As New Rectangle(0, 0, Panel1.Width, Panel1.Height)

    ' Neues Brush-Objekt mit den gewnschten Farben und
    ' Farbverlauf-Richtung erstellen
    Dim oBrush As New LinearGradientBrush(oRect, Color.FromArgb(255, 231, 247, 255), Color.FromArgb(255, 181, 214, 255), _
      LinearGradientMode.Vertical)

    ' Hintergrund-Farbverlauf anzeigen
    e.Graphics.FillRectangle(oBrush, oRect)
  End Sub

  Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
    ' Eigenschaften
    txtWinTitle.Text = "Wichtiger Hinweis"
    txtMain.Text = "Dieser Text steht ganz oben im Dialogfenster"
    txtContent.Text = "Und dieser Text gibt die Information des Dialogfensters an den Anwender aus."

    With cmbSymbol
      .Items.Add(New ListItemEx("NoIcon", 0))
      .Items.Add(New ListItemEx("WarningIcon", -1))
      .Items.Add(New ListItemEx("ErrorIcon", -2))
      .Items.Add(New ListItemEx("InfoIcon", -3))
      .Items.Add(New ListItemEx("QuestionIcon", 32514))
      .Items.Add(New ListItemEx("SecurityIcon", -4))
      .Items.Add(New ListItemEx("SecurityIconBlue", -5))
      .Items.Add(New ListItemEx("SecurityIconWarning", -6))
      .Items.Add(New ListItemEx("SecurityIconError", -7))
      .Items.Add(New ListItemEx("SecurityIconOK", -8))
      .Items.Add(New ListItemEx("SecurityIconGrey", -9))

      .SelectedIndex = 6
    End With

    With CheckedListBox1
      .Items.Add(New ListItemEx("OK", 1))
      .Items.Add(New ListItemEx("Yes", 2))
      .Items.Add(New ListItemEx("No", 4))
      .Items.Add(New ListItemEx("Cancel", 8))
      .Items.Add(New ListItemEx("Retry", 16))
      .Items.Add(New ListItemEx("Close", 32))

      .SetItemChecked(0, True)
    End With
  End Sub

  Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click
    ' Task-Dialog anzeigen
    Dim buttons As Integer
    Dim icon As Integer

    icon = CType(cmbSymbol.SelectedItem, ListItemEx).ItemData
    For Each Item As ListItemEx In CheckedListBox1.CheckedItems
      buttons = buttons Or Item.ItemData
    Next

    Dim result As TaskDlgButton
    result = TaskDlg.Show(txtWinTitle.Text, txtMain.Text, txtContent.Text, buttons, icon)

    Label10.Text = "Ausgewhlte Schaltflche: " & result.ToString
    Label10.Visible = True
  End Sub
End Class
